#ifndef P_GRAFIK_H
 #define P_GRAFIK_H

 #define                     MAXX 319            /* Maximale X- und Y-Ordinate */
 #define                     MAXY 379

 #define                     SPRANZ 5            /* Anzahl der Sprites */

 #include                    <dos.h>
 #include                    <stdarg.h>
 #include                    "p_local.h"
 #include                    "p_fehler.h"
 #include                    "p_asm.h"

 typedef struct
 {                                               /* Pixel-Puffer fr GetVideo() und PutVideo() */
  BYTE                      *bitptr[4],          /* Zeiger auf Bit-Planes */
                             byproz[4],          /* Anzahl zu kopierender Bytes */
                             hoehe,              /* Anzahl der Zeilen */
                             hinter;
  int                        hight;
  int                        width;
 } PIXBUF;

 typedef                     PIXBUF *PIXPTR;     /* Zeiger auf einen Pixel-Puffer */

 typedef struct
 {                                               /* Pixel-Puffer fr GetVideo() und PutVideo() */
  void                      *bitptr[4];          /* Zeiger auf Bit-Planes */
 } BACKBUF;

 typedef                     BACKBUF *BACKPTR;   /* Zeiger auf einen Pixel-Puffer */

 typedef struct
 {                                               /* Erscheinungsbild eines Sprites */
  BYTE                       breite,             /* Breite gesamt */
                             hoehe;              /* Hhe in Punktzeilen */
  PIXPTR                     pixbp;              /* Zeiger auf Pixel-Block */
 } SPLOOK;

 typedef struct
 {                                               /* Sprite-Beschreiber (ID) */
  SPLOOK                    *splookp;            /* Zeiger auf Erscheinungsbild */
  int                        x[2], y[2],         /* Koordinaten in Seite 0 und 1 */
                             old_x[2],old_y[2];
 } SPID;

 typedef struct
 {                                               /* beschreibt die verwalteten Sprites */
  SPID                      *spidp;              /* Zeiger auf Sprite-Id */
  int                        deltax[2],          /* X-Verschiebung fr Page 0 und 1 */
                             deltay[2];          /* Y-Verschiebung fr Page 0 und 1 */
                             richtung;
 } SPRITES;

#define ALLOKBUF             ((PIXPTR) 0)        /* GetVideo(): Puffer allokieren */
#define ALLOKBACK            ((BACKPTR) 0)

#include                     "p_pacman.h"

 extern SPRITES              sprites[SPRANZ];
 extern BACKPTR              Back;
 extern BYTE                 page;               /* aktuell bearbeitete Seite */
 extern int                  x, y, x1, y1, dx, dy, ddx, ddy;

 /* Zeiger auf die Sprites */
 extern SPLOOK              *Pac[4][5];
 extern SPLOOK              *red[5][3];
 extern SPLOOK              *gelb[5][3];
 extern SPLOOK              *lila[5][3];
 extern SPLOOK              *gruen[5][3];
 extern SPLOOK              *augen[4];
 extern SPLOOK              *pacdead,*pacdeadv;
 extern SPLOOK              *z200,*z400,*z800,*z1600,*z3200,*z1000,*z2000,*z4000,*z8000;
 extern SPLOOK              *z6400,*z12800,*z25600,*z51200,*sterne;
 extern SPLOOK              *z100,*z300,*z500,*z600,*z3000,*z5000,*z10000,*z15000,*z20000;
 extern SPLOOK              *z25000,*z30000,*z700,*z900,*z1100,*z1200,*z1300,*z1400,*z1700;
 extern SPLOOK              *z1800,*z1900,*z1500;
 extern SPLOOK              *dead[14];
 extern PIXPTR               lr,lo,lu,lro,lru,lou,lrou;
 extern PIXPTR               l,r,o,u,ro,ru,rou,ou,nichts,gar_nichts,zz;
 extern PIXPTR               kl_pac,Bonus[BON_MAX],void_Bonus,lab_col;
 extern PIXPTR               dot1_col,dot2_col,diav;
 extern PIXPTR               Extra_Bonus[16];
 extern PIXPTR               dia;
 extern PIXPTR               z_0,z_1,z_2,z_3,z_4,z_5,z_6,z_7,z_8,z_9;
 extern int                  bild;

 BACKPTR                     Save_Back(BYTE page,BACKPTR bufptr);
 PIXPTR                      GetVideo(BYTE page,int x1,int y1,BYTE breite,BYTE hoehe,PIXPTR bufptr);
 PIXPTR                      ompile_Weg(int breite,int hoehe,int xx,int yy,int farbe);
 PIXPTR                      Compile_Weg(char *Name,int farbe);
 SPLOOK                     *CompileSprite(int xx,int yy,int Grund);
 SPID                       *CreateSprite(SPLOOK *splookp);
 BYTE                        IsVga(void);
 BYTE                        MoveSprite1(SPID *spidp, BYTE seite, int deltax, int deltay);
 void                        PrintSprite(register SPID *spidp, BYTE seite);
 void                        RestoreSpriteBg(register SPID *spidp, BYTE seite);
 void                        RestoreSpriteBgNo(int sprite_no, BYTE seite);
 void                        SetSprite(SPID *spidp, int x0, int y0, int x1, int y1);
 void                        RemoveSprite(SPID *spidp);
 void                        Free_Back(BACKPTR bufptr);
 void                        PutVideo(PIXPTR bufptr, BYTE page, int x1, int y1, BOOL bg);
 void                        Get_Back(BYTE page,BACKPTR bufptr);
 void                        FreePixBuf(PIXPTR bufptr);
 void                        PutBack(BACKPTR backptr,PIXPTR bufptr,int x1, int y1);
 void                        build(void);
 void                        init_stuff(void);
 void                        compile_pacman(void);
 void                        compile_gelb(void);
 void                        compile_lila(void);
 void                        compile_red(void);
 void                        compile_blau(void);
 void                        compile_gruen(void);
 void                        compile_lab(void);
 void                        compile_dots(int farbe);
 void                        compile_bonus_1(void);
 void                        compile_bonus_2(void);
 void                        compile_bonus_3(void);
 void                        SwapInt(int *i1, int *i2);
 void                        Line(int x1,int y1,int x2,int y2,BYTE farbe);
 void                        PrintChar(char zeichen, int x, int y, BYTE vg, BYTE hg);
 void                        GrafPrintf(int x, int y, BYTE vg, BYTE hg, char * string, ...);
 void                        gprintf(int x, int y, BYTE vg, BYTE hg, char * string, ...);
 void                        warte_d(int zeit);
#endif
