#ifndef P_IO_H
 #define P_IO_H

 #include                   <stdio.h>
 #include                   <dos.h>
 #include                   "p_local.h"
 #include                   "p_asm.h"
 #include                   "p_grafik.h"
 #include                   "p_sound.h"

 #define OUT_LEFT            1                   /* fr Kollisionsmarkierung in SpriteMove() */
 #define OUT_TOP             2
 #define OUT_RIGHT           4
 #define OUT_BOTTOM          8
 #define OUT_NO              0                   /* nirgendwo drauen */

 #define K_ACHSENGLEICH      106
 #define K_HOCH              56
 #define K_RUNTER            50
 #define K_LINKS             52
 #define K_RECHTS            54

 #define C_ACHSENGLEICH      152
 #define C_HOCH              72
 #define C_RUNTER            80
 #define C_LINKS             75
 #define C_RECHTS            77

 typedef struct
 {                                               /* beschreibt die Position eines Joysticks */
  int                        x;
  int                        y;
 } JSPOS;

 extern int                  dir, key, lastkey, key_flag;
 extern int                  Achsengleich, Hoch, Runter, Rechts, Links;

 extern JSPOS                jsp[2];             /* aktuelle Joystick-Position */
 extern BYTE                 aktstick;           /* ausgewhlter Joystick */
 extern BYTE                 j1but[2];           /* Button 1 auf Joystick 1 und 2 */
 extern BYTE                 j2but[2];           /* Button 2 auf Joystick 1 und 2 */
 extern BYTE                 out;                /* nimmt Flags fr Seitenkollision auf */
 extern int                  maxx, maxy;         /* maximale Joystick-Position */
 extern int                  minx, miny;         /* minimale Joystick-Position */
 extern int                  x_plus,x_minus;
 extern int                  y_plus,y_minus;
 extern int                  allow_int;
 extern int                  INIT_JOY;
 extern int                  JOYSTICK;
 extern int                  Sim_Taste, Key_status;
 extern int                  i_warte;

 BYTE                        demo_game_get_key(void);
 BYTE                        game_get_key(void);
 BYTE                        Get_Dir(register BYTE dir);
 BYTE                        get_key(void);
 int                         get_file_int(FILE *Load_Lab);
 void                        GetJoyButton(BYTE *j1b1, BYTE *j1b2);
 void                        GetJoyPos(JSPOS *Js1Ptr);
 void                        InitJoy(int page);
 void                        Do_Joy(void);
 void                        load_laby(BYTE lab_col);
 void                        load_lab(int nummer,char *File_Name);
 void                        get_lab(int nummer);
 void                        get_Extra(void);
 void                        get_max_bonus(void);
 void                        get_default(void);
 void                        save_config(void);
 void                        warte(void);
 void                        Do_Input(void);
 void                        K_Clear(void);

#endif
